import { Promise as Promise$1 } from 'rsvp';

class Action {
  constructor(nameOrHandler, args = [], opts = {}) {
    if (typeof nameOrHandler === 'function') {
      this.handler = nameOrHandler;
    } else {
      this.name = nameOrHandler;
    }
    this.reversed = opts.reversed;
    this.args = args;
  }
  validateHandler(transitionMap) {
    if (!this.handler) {
      this.handler = transitionMap.lookup(this.name);
    }
  }
  run(context) {
    return new Promise$1((resolve, reject) => {
      Promise$1.resolve(this.handler.apply(context, this.args)).then(resolve, reject);
    });
  }
}

export { Action as default };
//# sourceMappingURL=action.js.map
